#include <fstream>
#include <iostream>
#include <cstring>
#include <cstdlib>
#include <algorithm>

#define INFINIT 1<<20

using namespace std;

struct muchie{
	int i,j,c;
	
	friend bool operator < (const muchie &A, const muchie &B){
		return A.c < B.c;
	}
	
	
	friend ostream & operator <<(ostream & out, const muchie &A){
		out << "(" << A.i << " , " << A.j << " , " << A.c << ")";
		return out;
	}
	
	
	muchie(){
		i=0,j=0,c=0;
	}
	muchie(int I,int J,int C){
		i=I, j=J, c=C;
	}
};


int a[100][100],n,m;
muchie L[5000];

void citire(int r){
	char nf[100];
	sprintf(nf,"r%d.in",r);
	ifstream fin(nf);
	if(!fin){
		cerr << "Nu pot deschide fisierul " << nf << endl;
		exit(1);
	}
	fin >> n;
	cout << n << endl;
	for(int i=1;i<=n;++i)
		for(int j=i+1;j<=n;++j)
			a[i][j] = a[j][i] = INFINIT;
	m=0;
	int i,j,c;
	while(fin >> i >> j >> c)
		cout << i << " " << j << " " << c << endl , a[i][j] = a[j][i] = c, L[++m] = muchie(i,j,c);
}

void afis(int *v, int n, string mesaj="", int nl = 0){
	cout << mesaj << " : ";
	for(int i=1;i<=n;++i)
		if(v[i]==INFINIT)
			cout << "~ ";
		else
			if(v[i]==-1)
				cout << "- ";
			else
				cout << v[i] << " ";
		
	if(nl)
		cout << endl;
	else
		cout << "    ";
}

void dijkstra(int st){
	int v[100], t[100], d[100];
	for(int i=1 ; i<=n ; ++i)
		v[i] = 0, t[i]=a[st][i]==INFINIT?-1:st, d[i]=a[st][i];
	v[st]=1,t[st]=0;
	d[0]=INFINIT;
	cout << "Algoritmul lui Dijkstra pornind din " << st << endl;
	cout << "Start "<< st << "    ->   ";
	while(1){
		afis(v,n,"v");
		afis(t,n,"t");
		afis(d,n,"d",1);
		int  p = 0;
		for(int i=1;i<=n;++i)
			if(v[i]==0 && d[i]<d[p])
				p=i;
		if(p==0)
			break;
		cout << "Aleg "<< p << "    ->   ";
		v[p]=1;
		for(int i=1;i<=n;++i)
			if(v[i]==0 && d[i] > d[p]+a[p][i])
				t[i]=p, d[i] = d[p]+a[p][i];
	}
	cout << "La final: "<< endl;
	afis(v,n,"v",1);
	afis(t,n,"t",1);
	afis(d,n,"d",1);
}


void prim(int st){
	int v[100], t[100], d[100];
	for(int i=1 ; i<=n ; ++i)
		v[i] = 0, t[i]=a[st][i]==INFINIT?-1:st, d[i]=a[st][i];
	v[st]=1,t[st]=0;
	d[0]=INFINIT;
	cout << "Algoritmul lui Prim pornind din " << st << endl;
	cout << "Start "<< st << "    ->   ";
	while(1){
		afis(v,n,"v");
		afis(t,n,"t");
		afis(d,n,"d",1);
		int  p = 0;
		for(int i=1;i<=n;++i)
			if(v[i]==0 && d[i]<d[p])
				p=i;
		if(p==0)
			break;
		cout << "Aleg "<< p << "    ->   ";
		v[p]=1;
		for(int i=1;i<=n;++i)
			if(v[i]==0 && d[i] > a[p][i])
				t[i]=p, d[i] = a[p][i];
	}
	cout << "La final: "<< endl;
	afis(v,n,"v",1);
	afis(t,n,"t",1);
	afis(d,n,"d",1);
}

void kruskal(){
	cout << "Algoritmul lui Kruskal\n";
	sort(L+1,L+m+1);
	cout << "Muchiile sortate dupa cost sunt:" << endl;
	for(int i=1;i<=m;++i)
		cout << L[i] << endl;
	cout << "Muchiile din arbore sunt:" << endl;
	int v[100];
	for(int i=1;i<=n;++i)
		v[i] = i;
	for(int i=1;i<=m;++i)
		if(v[L[i].i]!=v[L[i].j]){
			cout << L[i] << endl;
			int ii=v[L[i].i], jj=v[L[i].j];
			if(ii>jj)
				swap(ii,jj);
			for(int j=1;j<=n;++j)
				if(v[j]==jj)
					v[j]=ii;
		}
}

int main(){
	int rand, startD, startP;
	cout << "Randul: ";	cin >> rand;
	citire(rand);
	cout << "varful de start pentru Dijkstra: "; cin >> startD;
	dijkstra(startD);
	cout << "varful de start pentru Prim    : "; cin >> startP;
	prim(startP);
	char ss[1000];
	cin.get();
	cout << "Apasa ENTER pentru Kruskal";
	cin.getline(ss,1000);
	kruskal();
	return 0;
}
